-- EasySerum by Xinhuan

-- English Localization (base locale)
local L = {
	-- Item Names as spelt by the quest giver whispers
	["Abomination Guts"] = true,
	["Amberseed"] = true,
	["Ancient Ectoplasm"] = true,
	["Blight Crystal"] = true,
	["Chilled Serpent Mucous"] = true, -- Yes, the item is "Chilled Serpent Mucus"
	["Crushed Basilisk Crystals"] = true,
	["Crystallized Hogsnot"] = true,
	["Frozen Spider Ichor"] = true,
	["Ghoul Drool"] = true,
	["Hairy Herring Head"] = true, -- Yes, the crate is "Hairy Herring Heads"
	["Icecrown Bottled Water"] = true,
	["Knotroot"] = true,
	["Muddy Mire Maggot"] = true, -- Yes, the sack is "Muddy Mire Maggots"
	["Pickled Eagle Egg"] = true,
	["Prismatic Mojo"] = true,
	["Pulverized Gargoyle Teeth"] = true,
	["Putrid Pirate Perspiration"] = true,
	["Raptor Claw"] = true,
	["Seasoned Slider Cider"] = true,
	["Shrunken Dragon's Claw"] = true,
	["Speckled Guano"] = true,
	["Spiky Spider Egg"] = true, -- Yes, the object is "Spiky Spider Eggs"
	["Trollbane"] = true,
	["Wasp's Wings"] = true,
	["Withered Batwing"] = true,
	-- Other text
	["Left"] = true,
	["Right"] = true,
	["Crates"] = true,
	["Barrels"] = true,
	["Sacks"] = true,
	["%s: %s side, Case %d, Row %d, Item %d"] = true,
	["%s: %s side, %s on the Floor"] = true,
}
-- Convert the "true" entries to the same as the key
for k, v in pairs(L) do
	if v == true then
		L[k] = k
	end
end

-- Other locales
local locale = GetLocale()
if locale == "deDE" then
	-- Item Names as spelt by the quest giver whispers
	L["Abomination Guts"] = ""
	L["Amberseed"] = ""
	L["Ancient Ectoplasm"] = ""
	L["Blight Crystal"] = ""
	L["Chilled Serpent Mucous"] = ""
	L["Crushed Basilisk Crystals"] = ""
	L["Crystallized Hogsnot"] = ""
	L["Frozen Spider Ichor"] = ""
	L["Ghoul Drool"] = ""
	L["Hairy Herring Head"] = ""
	L["Icecrown Bottled Water"] = ""
	L["Knotroot"] = ""
	L["Muddy Mire Maggot"] = ""
	L["Pickled Eagle Egg"] = ""
	L["Prismatic Mojo"] = ""
	L["Pulverized Gargoyle Teeth"] = ""
	L["Putrid Pirate Perspiration"] = ""
	L["Raptor Claw"] = ""
	L["Seasoned Slider Cider"] = ""
	L["Shrunken Dragon's Claw"] = ""
	L["Speckled Guano"] = ""
	L["Spiky Spider Egg"] = ""
	L["Trollbane"] = ""
	L["Wasp's Wings"] = ""
	L["Withered Batwing"] = ""
	-- Other text
	L["Left"] = ""
	L["Right"] = ""
	L["Crates"] = ""
	L["Barrels"] = ""
	L["Sacks"] = ""
	L["%s: %s side, Case %d, Row %d, Item %d"] = ""
	L["%s: %s side, %s on the Floor"] = ""
end

-- Main addon frame
EasySerum = CreateFrame("Frame")
EasySerum:RegisterEvent("CHAT_MSG_RAID_BOSS_WHISPER")
EasySerum:SetScript("OnEvent", function(self, event, arg1, arg2)
	--local body = format(getglobal("CHAT_RAID_BOSS_WHISPER_GET")..arg1, arg2, arg2)
	local item = arg1:gsub("!", "")
	local where = self.info[item]
	if where then
		local side = floor(where / 1000)
		local case = floor(where % 1000 / 100)
		local row = floor(where % 100 / 10)
		local num = where % 10
		if case > 0 then
			print(L["%s: %s side, Case %d, Row %d, Item %d"]:format(item, side == 1 and L["Left"] or L["Right"], case, row, num))
		else
			print(L["%s: %s side, %s on the Floor"]:format(item, side == 1 and L["Left"] or L["Right"], num == 1 and L["Sacks"] or num == 2 and L["Barrels"] or L["Crates"]))
		end
	end
end)

EasySerum.info = {
	--["Item name"] = (Left and 1 or 2)*1000 + (CaseNumber or 0)*100 + ShelfNumber*10 + ItemNumber
	--So "Speckled Guano" is 2241 which means Right side, Case 2 (from left), Shelf 4 (from top), Item 1 (from left)
	[L["Abomination Guts"]] = 1434,
	[L["Amberseed"]] = 2133,
	[L["Ancient Ectoplasm"]] = 2132,
	[L["Blight Crystal"]] = 1232,
	[L["Chilled Serpent Mucous"]] = 1133,
	[L["Crushed Basilisk Crystals"]] = 1242,
	[L["Crystallized Hogsnot"]] = 2134,
	[L["Frozen Spider Ichor"]] = 1332,
	[L["Ghoul Drool"]] = 2344,
	[L["Hairy Herring Head"]] = 2003,
	[L["Icecrown Bottled Water"]] = 2121,
	[L["Knotroot"]] = 2141,
	[L["Muddy Mire Maggot"]] = 2001,
	[L["Pickled Eagle Egg"]] = 2122,
	[L["Prismatic Mojo"]] = 1142,
	[L["Pulverized Gargoyle Teeth"]] = 2124,
	[L["Putrid Pirate Perspiration"]] = 2123,
	[L["Raptor Claw"]] = 1123,
	[L["Seasoned Slider Cider"]] = 2002,
	[L["Shrunken Dragon's Claw"]] = 2333,
	[L["Speckled Guano"]] = 2241,
	[L["Spiky Spider Egg"]] = 2434,
	[L["Trollbane"]] = 2431,
	[L["Wasp's Wings"]] = 2131,
	[L["Withered Batwing"]] = 2143,
}
